﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Taschenrechner
{
    class Buffer
    {
        private Register register;

        public Buffer(Register register)
        {
            this.register = register;
        }

        public void Append(char c)
        {
            string content = register[Constants.INPUT_BUFFER];
            content = c + content;
            register[Constants.INPUT_BUFFER] = content;
        }

        public void Append(string s)
        {
            string content = register[Constants.INPUT_BUFFER];
            content = s + content;
            register[Constants.INPUT_BUFFER] = content;
        }

        public bool IsEmpty()
        {
            string content = register[Constants.INPUT_BUFFER];
            return content.Length == 0;
        }

        public string GetContent()
        {
            string content = register[Constants.INPUT_BUFFER];
            return content;
        }

        public char ConsumeNextChar()
        {
            if (this.IsEmpty())
            {
                throw new TaschenrechnerException("buffer is empty");
            }

            string content = register[Constants.INPUT_BUFFER];
            register[Constants.INPUT_BUFFER] = content.Substring(1);
            return content[0];
        }
    }
}
