﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Taschenrechner.operators;
using Taschenrechner.states;

namespace Taschenrechner
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {
                Parse();
            }
            catch (Exception e)
            {
                Console.WriteLine(e.Message);
                Console.ReadLine();
            }
        } 

        static void Parse()
        {
            Context context = new Context();

            long[] reg = new long[4];

            while (true)
            {
                // read new key if buffer is empty
                if (context.buffer.IsEmpty())
                {
                    // show registers
                    for (int i = -4, j = 0; i < 0; i++, j++)
                    {
                        Console.SetCursorPosition(0, j);
                        reg[j] = long.Parse(context.register[i]);
                        Console.WriteLine("Register " + i + ":" + reg[j] + ">: " + context.register[reg[j]]);
                    }

                    Console.WriteLine("");
                    Console.WriteLine("<Prime Test>");
                    Console.WriteLine("\tWrite Number to register 1000 and execute register 2000");
                    Console.WriteLine("\t'111' == number is NOT prime");
                    Console.WriteLine("\t'222' == number is prime");
                    Console.WriteLine("");

                    Console.WriteLine(context.register.ToString());

                    char readKey = Console.ReadKey().KeyChar;
                    context.buffer.Append(readKey);
                }
                char c = context.buffer.ConsumeNextChar();


                if (Char.IsDigit(c))
                {
                    context.HandleNumber(c);
                }
                else if (Constants.QUIT == c)
                {
                    break;
                }
                else if (Constants.DELIMITER == c)
                {
                    context.HandleDelimiter();
                }
                else if (Constants.QUOTE == c)
                {
                    context.HandleQuote();
                }
                else
                {
                    context.HandleOperator(c);
                }

                // debug output
                //Console.SetCursorPosition(0, 5);
                //Console.WriteLine("\n" + context.register);
            } //while loop
        } // parse method
    } //class
}
