﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Taschenrechner
{
    class Register
    {
        private Dictionary<long,string> dic = new Dictionary<long, string>();

        public Register()
        {
            this[Constants.INPUT_BUFFER] = "";
            this[Constants.PRIME_TEST] = "'1000r2/1001s1001r1+1001s0,1002s2,1003s1,1004s'1000r1003r%1004s1003r1+1003s1003r1001r<1004r0>&1006+a'1005s''1006s1003r1001r<1004r0>&1006+a'111,1002s'1007s'222,1002s'1008s1004r0=1008+a1002,4~s'";
            this[Constants.PRIME_TEST_FAST] = "'1000r2/1001s0,1002s'1000r1001r/1001r+2/2+1001s1002r1+1002s1002r10<1004+a'1003s''1004s1002r10<1004+a1001r1+1001s0,1005s3,1006s1000r2%1007s'1000r1006r%1007s1006r2+1006s1006r1001r<1007r0>&1009+a'1008s''1009s1006r1001r<1007r0>&1009+a'111,1005s'1010s'222,1005s'1011s1007r0=1000r3>&1011+a1005,4~s'";
        }

        public string this[long index]
        {
            get {
                if (index < -7)
                    throw new TaschenrechnerException("invalid register");

                string s = "";
                dic.TryGetValue(index, out s);

                return (s == null) ? "0" : s; 
            }
            set
            {
                if (index < -7)
                    throw new TaschenrechnerException("invalid register");

                dic[index] = value;
            }
        }

        public override string ToString()
        {
            string result = "";

            for (int i = 0; i < 20; i++)
            {
                result += " # " + this[i];
            }

            return result;
        }
    }
}
