﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Taschenrechner
{
    class Stack
    {
        private Register register;

        public long StackPointer
        {
            get 
            { 
                return long.Parse(register[Constants.STACK_POINTER]); 
            }
            private set
            {
                register[Constants.STACK_POINTER] = value.ToString();
            }
        }

        public Stack(Register register)
        {
            this.register = register;
        }

        public void Push(string s)
        {
            StackPointer++;
            register[StackPointer] = s;
        }

        public void Push(long s)
        {
            StackPointer++;
            register[StackPointer] = s.ToString();
        }

        public String Pop()
        {
            if (StackPointer < 1)
                throw new TaschenrechnerException("stack is empty");

            String s = register[StackPointer];

            StackPointer--;

            return s;
        }

        public long PopAsLong()
        {
            long val;

            try
            {
                val = long.Parse(Pop());
            }
            catch (Exception)
            {
                throw new TaschenrechnerException("cannot pop string as number");
            }
            return val;
        }

        public bool NextElementIsExpression()
        {
            string val = register[StackPointer];

            return Util.IsExpression(val);
        }

        public string PopAsExpression()
        {
            if (NextElementIsExpression() == false)
            {
                throw new TaschenrechnerException("cannot pop number as expression");
            }

            return (Util.ExtractExpression(Pop()));
        }
    }
}
