﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Taschenrechner.states;

namespace Taschenrechner.operators
{
    class ApplyOperator : IOperator
    {
        #region IOperator Members

        public void Execute(Context context)
        {
            Stack stack = context.stack;

            string val;
            if (stack.NextElementIsExpression())
            {
                val = stack.PopAsExpression();
            }
            else
            {
                val = context.register[stack.PopAsLong()];

                if (Util.IsExpression(val) == false)
                {
                    throw new TaschenrechnerException("register doesn't contain expression");
                }

                val = Util.ExtractExpression(val);
            }

            context.buffer.Append(val);
        }

        #endregion
    }
}
