﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Taschenrechner.states
{
    class EvalState : IState
    {
        #region IState Members

        public void HandleNumber(Context context, char number)
        {
            Append(context, number);
        }

        public void HandleDelimiter(Context context)
        {
            Append(context, Constants.DELIMITER);
        }

        public void HandleQuote(Context context)
        {
            Append(context, Constants.QUOTE);
            context.currentState = context.normalState;
        }

        public void HandleOperator(Context context, char op)
        {
            Append(context, op);
        }

        public string GetCode()
        {
            return "1";
        }

        #endregion

        private void Append(Context context, char c)
        {
            string s = context.stack.Pop();
            s += c.ToString();
            context.stack.Push(s);
        }
    }
}
