﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Taschenrechner.operators;

namespace Taschenrechner.states
{
    class NormalState : IState
    {
        #region IState Members

        public void HandleNumber(Context context, char number)
        {
            context.stack.Push(number.ToString());
            context.currentState = context.numberState;
        }

        public void HandleDelimiter(Context context)
        {
            throw new NotImplementedException();
        }

        public void HandleQuote(Context context)
        {
            context.stack.Push(Constants.QUOTE.ToString());
            context.currentState = context.evalState;
        }

        public void HandleOperator(Context context, char op)
        {
            IOperator opObj = context.operatorDic[op];
            opObj.Execute(context);

            context.currentState = context.normalState;
        }

        public string GetCode()
        {
            return "0";
        }

        #endregion
    }
}
