﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Taschenrechner.operators;

namespace Taschenrechner.states
{
    class NumberState : IState
    {
        #region IState Members

        public void HandleNumber(Context context, char number)
        {
            long val = long.Parse(context.stack.Pop());
            val = val * 10 + long.Parse(number.ToString());
            context.stack.Push(val);
        }

        public void HandleDelimiter(Context context)
        {
            context.currentState = context.normalState;
        }

        public void HandleQuote(Context context)
        {
            context.stack.Push(Constants.QUOTE.ToString());
            context.currentState = context.evalState;
        }

        public void HandleOperator(Context context, char op)
        {
            IOperator opObj;
            try
            {
                opObj = context.operatorDic[op];
            }
            catch (KeyNotFoundException)
            {
                throw new TaschenrechnerException("invalid operator");
            }
            opObj.Execute(context);

            context.currentState = context.normalState;
        }

        public string GetCode()
        {
            return "-1";
        }

        #endregion
    }
}
